
/*
 * This file is part of EKG/gEKG, a software package to record EKG.
 * Copyright  2003 Lars Stollenwerk
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version.  
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#ifndef EKGDEVICE_H
#define EKGDEVICE_H

#include <cstddef>

/** 
 * Ein EKGdevice ist eine Klasse, die Spannungstripletts
 * entgegennehmen und weitergeben kann.
 *
 * @author Lars Stollenwerk, Oktober 2002
 */
class EKGdevice
{
  public:
    /** 
     * Konstruktor
     */
    EKGdevice() : nextDevice(NULL) {}
    /**
     * virtuller destruktor.
     */
    virtual ~EKGdevice(){}
    /**
     * Dateneingang. Standardmig werden eingehende Daten an nextDevice
     * witergeleitet.
     * @param d Eingehender Datentripel.
     */
    virtual void input( float * d ) 
      { if ( nextDevice != NULL ) nextDevice->input( d ); }
    /** 
     * Anschlu eines nachfolgenden Gertes.
     * @param Zeiger auf neues nachfolgendes Gert.
     */
    virtual void connectTo( EKGdevice * d ) { nextDevice = d; }
  protected:
    /**
     * Zeiger auf nachfolgendes Gert.
     */
    EKGdevice * nextDevice;
};

#endif
